package com.example.collectionofshortstories.navigation

import androidx.compose.runtime.Composable
import androidx.lifecycle.ViewModel
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import com.example.collectionofshortstories.view.authorization.AuthorizationAndLogin
import com.example.collectionofshortstories.view.catalog.Catalog
import com.example.collectionofshortstories.view.start.LoadProgram

@Composable
fun Navigathion() {
    val navController = rememberNavController()
    NavHost(
        navController = navController,
        startDestination = Routes.START
    ) {
        composable(Routes.START) {
            LoadProgram(navController)
        }
        composable(Routes.AUTH) {
            AuthorizationAndLogin(navController)
        }
        composable(Routes.CATALOG) {
            Catalog(navController)
        }
    }
}
