package com.example.collectionofshortstories.view.authorization

import android.util.Log
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import androidx.navigation.NavHostController
import com.example.collectionofshortstories.domain.untils.Constants
import com.example.collectionofshortstories.navigation.Routes
import com.example.collectionofshortstories.view.catalog.Catalog
import io.github.jan.supabase.gotrue.auth
import io.github.jan.supabase.gotrue.providers.builtin.Email
import kotlinx.coroutines.launch

class AuthorizationViewModel(): ViewModel() {


    fun onSignInEmailPassword(emailUser: String, passwordUser: String) {
        viewModelScope.launch {
            try {
                val user = Constants.supabase.auth.signInWith(Email) {
                    email = emailUser
                    password = passwordUser

                }
                Log.d("user", Constants.supabase.auth.currentUserOrNull()!!.id.toString())

            } catch (e: Exception) {
                println("Error")
                println(e.message.toString())
            }
        }
    }
}