package com.example.collectionofshortstories.view.catalog

import android.util.Log
import androidx.compose.runtime.Composable
import androidx.compose.runtime.LaunchedEffect
import androidx.compose.runtime.MutableState
import androidx.compose.runtime.State
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.rememberCoroutineScope
import androidx.compose.runtime.setValue
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.example.collectionofshortstories.domain.untils.Constants
import com.example.collectionofshortstories.model.Article
import com.example.collectionofshortstories.model.Role
import com.example.collectionofshortstories.model.User
import io.github.jan.supabase.gotrue.auth
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.StateFlow
import kotlinx.coroutines.flow.asStateFlow
import kotlinx.coroutines.launch
import kotlinx.coroutines.withContext

class CatalogViewModel(): ViewModel() {
    private val _articles: MutableStateFlow<List<Article>> = MutableStateFlow( listOf() )
    val articles: StateFlow<List<Article>> = _articles.asStateFlow()

    private val _role_name: MutableStateFlow<String> = MutableStateFlow("")
    val role_name: StateFlow<String> = _role_name.asStateFlow()

    fun GetArticles() {
        viewModelScope.launch {
            withContext(Dispatchers.IO) {
                val updatedCategories = Constants.supabase.from("articles")
                    .select()
                _articles.value = updatedCategories.decodeList<Article>()
            }
        }
    }

    fun GetUserRole() {
        viewModelScope.launch {
            try {
                val userDate = Constants.supabase.from("users").select {
                    filter {
                        eq("id", Constants.supabase.auth.currentUserOrNull()!!.id)
                    }
                }.decodeSingleOrNull<User>()
                println(userDate.toString())
                println(userDate!!.id_role.toString())
                val userRoleId = userDate.id_role
                println(userRoleId.toString())
                val roleDate = Constants.supabase.from("roles")
                    .select {
                        filter {
                            eq("id", userRoleId)
                        }
                    }.decodeSingleOrNull<Role>()
                if (roleDate == null) {
                    Log.d("DSDSDSDSD","BAS")
                }
                else {
                    Log.d("DSDSDSDSD","TES")
                    _role_name.value = roleDate.title
                }
            } catch (e: Exception){
                Log.d("DSDSDSDSD",e.message.toString())
            }


        }
    }
}